#ifndef _CAN_BITTIMING_H
#define _CAN_BITTIMING_H

#include "./can_sysdep.h"

/*
 * CAN harware-dependent bit-timing constant
 *
 * Used for calculating and checking bit-timing parameters
 */

struct can_bittiming_const {
	char name[16];          /* Name of the CAN controller hardware */
	uint32_t tseg1_min;        /* Time segement 1 = prop_seg + phase_seg1 */
	uint32_t tseg1_max;
	uint32_t tseg2_min;        /* Time segement 2 = phase_seg2 */
	uint32_t tseg2_max;
	uint32_t sjw_max;          /* Synchronisation jump width */
	uint32_t brp_min;          /* Bit-rate prescaler */
	uint32_t brp_max;
	uint32_t brp_inc;
};

#endif /*_CAN_BITTIMING_H*/
